#-------------------------------------------------------------------------------
# Name:        Domain Report
#
#-------------------------------------------------------------------------------

import arcpy, os

# get parameters from the tool
ingdb = arcpy.GetParameterAsText(0)
outputDir = arcpy.GetParameterAsText(1)
outputName =  arcpy.GetParameterAsText(2)

textFile = (outputDir + os.sep + outputName + ".csv")
f = open(textFile, "a")
f.write("FeatureClass" + "," + "FieldName" + "," + "FieldDomain" + "\n")   #write headers

# get a list all Feature Classes and tables in a geodatabase, including inside Feature Datasets
arcpy.env.workspace = ingdb
fcs = []
tabList = arcpy.ListTables()
for tab in tabList:
    fcs.append(tab)
for fds in arcpy.ListDatasets('','feature') + ['']:
    for fc in arcpy.ListFeatureClasses('','',fds):
        fcs.append(os.path.join(fds, fc))


# based on the list of feature classes collected above, this will create a list of fields
# and the write out the feature class, field name and domain name.
for fc in fcs:
    fields = arcpy.ListFields(fc)
    for field in fields:
        # check to see if there is a value in the domain property, basically if string != "":
        if field.domain:
            f.write(fc + "," + field.name + "," + field.domain + "\n")
            arcpy.AddMessage("FC={0} FieldName={1} Domain={2}".format(fc,field.name,field.domain))
f.close()